const config = require('config')
const { get, isEmpty } = require('lodash')
const Email = require('@pubsweet/component-email-templating')

const {
  User,
  services,
  Fragment,
  Collection,
} = require('pubsweet-component-helper-service')

const { getEmailCopy } = require('./emailCopy')
const helpers = require('./helpers')

const editorialAssistantEmail = config.get('journal.staffEmail')
const { name: journalName } = config.get('journal')

module.exports = {
  // async sendNotifications({
  //   hasEQA,
  //   baseUrl,
  //   fragment,
  //   UserModel,
  //   collection,
  //   targetUserName,
  //   isEditorInChief,
  //   newRecommendation,
  // }) {
  //   const fragmentHelper = new Fragment({ fragment })
  //   const parsedFragment = await fragmentHelper.getFragmentData({
  //     handlingEditor: collection.handlingEditor,
  //   })
  //   const {
  //     activeAuthors,
  //     submittingAuthor,
  //   } = await fragmentHelper.getAuthorData({ UserModel })

  //   const subjectBaseText = `${collection.customId}: Manuscript`
  //   const titleText = `The manuscript titled "${parsedFragment.title}" by ${
  //     submittingAuthor.firstName
  //   } ${submittingAuthor.lastName}`

  //   const userHelper = new User({ UserModel })
  //   const eicName = await userHelper.getEiCName()

  //   let email = new Email({
  //     type: 'user',
  //     content: {
  //       signatureName: eicName,
  //       unsubscribeLink: baseUrl,
  //       ctaText: 'MANUSCRIPT DETAILS',
  //       signatureJournal: journalName,
  //       ctaLink: services.createUrl(
  //         baseUrl,
  //         `/projects/${collection.id}/versions/${fragment.id}/details`,
  //       ),
  //     },
  //   })

  //   const { recommendation, recommendationType } = newRecommendation

  //   // the EiC recommends to publish so an email to the EQA needs to be sent,
  //   // one requesting approval or one informing them that the manuscript has been published
  //   if (
  //     isEditorInChief &&
  //     recommendation === 'publish' &&
  //     collection.technicalChecks.token
  //   ) {
  //     sendEQAEmail({
  //       email,
  //       eicName,
  //       baseUrl,
  //       titleText,
  //       collection,
  //       subjectBaseText,
  //     })
  //   }

  //   const hasPeerReview = !isEmpty(collection.handlingEditor)
  //   const { customId } = collection
  //   const collHelper = new Collection({ collection })

  //   // send HE emails when a review is submitted
  //   // or when the EiC makes a recommendation after peer review
  //   if (
  //     recommendationType === 'review' ||
  //     (isEditorInChief &&
  //       hasPeerReview &&
  //       (recommendation !== 'publish' || hasEQA))
  //   ) {
  //     const handlingEditor = get(collection, 'handlingEditor', {})
  //     const heUser = await UserModel.find(handlingEditor.id)
  //     email = helpers.updateEmailContentForHE({
  //       email,
  //       baseUrl,
  //       eicName,
  //       customId,
  //       recommendation,
  //       recommendationType,
  //       heLastName: collHelper.getHELastName(),
  //       handlingEditor: heUser,
  //     })
  //     const emailType = helpers.getEmailTypeByRecommendationForHE({
  //       recommendation,
  //       recommendationType,
  //     })
  //     const comments = helpers.getEiCCommentsForHE({ newRecommendation })
  //     helpers.sendHandlingEditorEmail({
  //       email,
  //       comments,
  //       emailType,
  //       titleText,
  //       targetUserName,
  //     })
  //   }

  //   if (
  //     recommendationType === 'review' ||
  //     recommendation === 'return-to-handling-editor'
  //   ) {
  //     return
  //   }

  //   // when publishing, only send emails to authors if the manuscript has passed EQA
  //   if (isEditorInChief && (recommendation !== 'publish' || hasEQA)) {
  //     // send all authors email
  //     const emailType = helpers.getEmailTypeByRecommendationForAuthors({
  //       recommendation,
  //       hasPeerReview,
  //     })

  //     let comments
  //     if (hasPeerReview) {
  //       comments = helpers.getHEComments({
  //         heRecommendation: parsedFragment.heRecommendation,
  //       })
  //     } else {
  //       comments = newRecommendation.comments[0].content
  //     }

  //     const authors = helpers.getAllAuthors({
  //       comments,
  //       emailType,
  //       title: parsedFragment.title,
  //       fragmentAuthors: activeAuthors,
  //     })
  //     email = helpers.updateEmailContentForAllAuthors({
  //       email,
  //       eicName,
  //       customId,
  //       recommendation,
  //     })
  //     helpers.sendAuthorsEmail({ email, authors, baseUrl })
  //   }

  //   // send email to SA when the HE requests a revision
  //   if (collection.status === 'revisionRequested') {
  //     const authorNoteText = helpers.getPrivateNoteTextForAuthor({
  //       newRecommendation,
  //     })
  //     const author = helpers.getSubmittingAuthor({
  //       journalName,
  //       authorNoteText,
  //       submittingAuthor,
  //       title: parsedFragment.title,
  //     })
  //     email = helpers.updateEmailContentForSA({
  //       email,
  //       customId,
  //       signatureName: get(collection, 'handlingEditor.name', eicName),
  //     })

  //     helpers.sendSubmittingAuthorEmail({ email, author, baseUrl })
  //   }

  //   if (!hasPeerReview) {
  //     return
  //   }

  //   let reviewers = []
  //   if (isEditorInChief) {
  //     if (recommendation !== 'publish' || hasEQA) {
  //       email = helpers.updateEmailContentForReviewers({
  //         email,
  //         customId,
  //         recommendation,
  //         signatureName: eicName,
  //       })
  //       reviewers = await helpers.getSubmittedReviewers({
  //         UserModel,
  //         titleText,
  //         fragmentHelper,
  //         recommendation,
  //       })
  //     }
  //   } else {
  //     email = helpers.updateEmailContentForReviewers({
  //       email,
  //       customId,
  //       subject: `Review no longer required`,
  //       signatureName: get(collection, 'handlingEditor.name', eicName),
  //     })

  //     reviewers = await helpers.getNoResponseReviewers({
  //       UserModel,
  //       titleText,
  //       fragmentHelper,
  //     })

  //     helpers.sendEiCsEmail({
  //       email,
  //       baseUrl,
  //       customId,
  //       userHelper,
  //       recommendation: newRecommendation,
  //       targetUserName: collHelper.getHELastName(),
  //       titleText: `the submission "${parsedFragment.title}" by ${
  //         submittingAuthor.firstName
  //       } ${submittingAuthor.lastName}`,
  //     })
  //   }

  //   helpers.sendReviewersEmail({ email, baseUrl, reviewers })
  // },
  async sendNotificationsWhenEiCMakesDecision({
    hasEQA,
    baseUrl,
    fragment,
    UserModel,
    collection,
    targetUserName,
    newRecommendation,
  }) {
    const fragmentHelper = new Fragment({ fragment })
    const parsedFragment = await fragmentHelper.getFragmentData({
      handlingEditor: collection.handlingEditor,
    })
    const {
      activeAuthors,
      submittingAuthor,
    } = await fragmentHelper.getAuthorData({ UserModel })

    const subjectBaseText = `${collection.customId}: Manuscript`
    const titleText = `The manuscript titled "${parsedFragment.title}" by ${
      submittingAuthor.firstName
    } ${submittingAuthor.lastName}`

    const userHelper = new User({ UserModel })
    const eicName = await userHelper.getEiCName()

    let email = new Email({
      type: 'user',
      content: {
        signatureName: eicName,
        unsubscribeLink: baseUrl,
        ctaText: 'MANUSCRIPT DETAILS',
        signatureJournal: journalName,
        ctaLink: services.createUrl(
          baseUrl,
          `/projects/${collection.id}/versions/${fragment.id}/details`,
        ),
      },
    })

    const { recommendation, recommendationType } = newRecommendation
    // the EiC recommends to publish so an email to the EQA needs to be sent,
    // one requesting approval or one informing them that the manuscript has been published
    if (recommendation === 'publish' && collection.technicalChecks.token) {
      sendEQAEmail({
        email,
        eicName,
        baseUrl,
        titleText,
        collection,
        subjectBaseText,
      })
    }

    const hasPeerReview = !isEmpty(collection.handlingEditor)
    const { customId } = collection
    const collHelper = new Collection({ collection })

    // send email to HE when the EiC makes a recommendation after peer review
    if (hasPeerReview && (recommendation !== 'publish' || hasEQA)) {
      const handlingEditor = get(collection, 'handlingEditor', {})
      const heUser = await UserModel.find(handlingEditor.id)
      email = helpers.updateEmailContentForHE({
        email,
        baseUrl,
        eicName,
        customId,
        recommendation,
        recommendationType,
        heLastName: collHelper.getHELastName(),
        handlingEditor: heUser,
      })
      const emailType = helpers.getEmailTypeByRecommendationForHE({
        recommendation,
        recommendationType,
      })
      const comments = helpers.getEiCCommentsForHE({ newRecommendation })
      helpers.sendHandlingEditorEmail({
        email,
        comments,
        emailType,
        titleText,
        targetUserName,
      })
    }

    // when publishing, only send emails to authors and reviewer if the manuscript has passed EQA
    if (recommendation !== 'publish' || hasEQA) {
      // send all authors email
      const emailType = helpers.getEmailTypeByRecommendationForAuthors({
        recommendation,
        hasPeerReview,
      })

      let comments
      if (hasPeerReview) {
        comments = helpers.getHEComments({
          heRecommendation: parsedFragment.heRecommendation,
        })
      } else {
        comments = newRecommendation.comments[0].content
      }

      const authors = helpers.getAllAuthors({
        comments,
        emailType,
        title: parsedFragment.title,
        fragmentAuthors: activeAuthors,
      })
      email = helpers.updateEmailContentForAllAuthors({
        email,
        eicName,
        customId,
        recommendation,
      })
      helpers.sendAuthorsEmail({ email, authors, baseUrl })

      email = helpers.updateEmailContentForReviewers({
        email,
        customId,
        recommendation,
        signatureName: eicName,
      })
      const reviewers = await helpers.getSubmittedReviewers({
        UserModel,
        titleText,
        fragmentHelper,
        recommendation,
      })
      helpers.sendReviewersEmail({ email, baseUrl, reviewers })
    }
  },
  async sendNotificationsWhenHEMakesRecommendation({
    baseUrl,
    fragment,
    UserModel,
    collection,
    newRecommendation,
  }) {
    const fragmentHelper = new Fragment({ fragment })
    const parsedFragment = await fragmentHelper.getFragmentData({
      handlingEditor: collection.handlingEditor,
    })
    const { submittingAuthor } = await fragmentHelper.getAuthorData({
      UserModel,
    })

    const titleText = `The manuscript titled "${parsedFragment.title}" by ${
      submittingAuthor.firstName
    } ${submittingAuthor.lastName}`

    const { customId } = collection
    const collHelper = new Collection({ collection })
    const userHelper = new User({ UserModel })
    const eicName = await userHelper.getEiCName()

    let email = new Email({
      type: 'user',
      content: {
        signatureName: eicName,
        unsubscribeLink: baseUrl,
        ctaText: 'MANUSCRIPT DETAILS',
        signatureJournal: journalName,
        ctaLink: services.createUrl(
          baseUrl,
          `/projects/${collection.id}/versions/${fragment.id}/details`,
        ),
      },
    })

    // send email to SA when the HE requests a revision
    if (collection.status === 'revisionRequested') {
      const authorNoteText = helpers.getPrivateNoteTextForAuthor({
        newRecommendation,
      })
      const author = helpers.getSubmittingAuthor({
        journalName,
        authorNoteText,
        submittingAuthor,
        title: parsedFragment.title,
      })
      email = helpers.updateEmailContentForSA({
        email,
        customId,
        signatureName: get(collection, 'handlingEditor.name', eicName),
      })

      helpers.sendSubmittingAuthorEmail({ email, author, baseUrl })
    }

    const hasPeerReview = !isEmpty(collection.handlingEditor)

    if (!hasPeerReview) {
      return
    }

    email = helpers.updateEmailContentForReviewers({
      email,
      customId,
      subject: `Review no longer required`,
      signatureName: get(collection, 'handlingEditor.name', eicName),
    })

    const reviewers = await helpers.getNoResponseReviewers({
      UserModel,
      titleText,
      fragmentHelper,
    })
    helpers.sendReviewersEmail({ email, baseUrl, reviewers })

    helpers.sendEiCsEmail({
      email,
      baseUrl,
      customId,
      userHelper,
      recommendation: newRecommendation,
      targetUserName: collHelper.getHELastName(),
      titleText: `the submission "${parsedFragment.title}" by ${
        submittingAuthor.firstName
      } ${submittingAuthor.lastName}`,
    })
  },
  async sendNotificationsWhenReviewerSubmitsReport({
    UserModel,
    collection,
    newRecommendation,
    baseUrl,
    fragment,
    targetUserName,
  }) {
    const fragmentHelper = new Fragment({ fragment })
    const parsedFragment = await fragmentHelper.getFragmentData({
      handlingEditor: collection.handlingEditor,
    })
    const { submittingAuthor } = await fragmentHelper.getAuthorData({
      UserModel,
    })

    const titleText = `The manuscript titled "${parsedFragment.title}" by ${
      submittingAuthor.firstName
    } ${submittingAuthor.lastName}`

    const userHelper = new User({ UserModel })
    const eicName = await userHelper.getEiCName()

    let email = new Email({
      type: 'user',
      content: {
        signatureName: eicName,
        unsubscribeLink: baseUrl,
        ctaText: 'MANUSCRIPT DETAILS',
        signatureJournal: journalName,
        ctaLink: services.createUrl(
          baseUrl,
          `/projects/${collection.id}/versions/${fragment.id}/details`,
        ),
      },
    })

    const { recommendation, recommendationType } = newRecommendation

    const handlingEditor = get(collection, 'handlingEditor', {})
    const heUser = await UserModel.find(handlingEditor.id)

    const { customId } = collection
    const collHelper = new Collection({ collection })

    email = helpers.updateEmailContentForHE({
      email,
      baseUrl,
      eicName,
      customId,
      recommendation,
      recommendationType,
      heLastName: collHelper.getHELastName(),
      handlingEditor: heUser,
    })
    const emailType = helpers.getEmailTypeByRecommendationForHE({
      recommendation,
      recommendationType,
    })
    const comments = helpers.getEiCCommentsForHE({ newRecommendation })
    helpers.sendHandlingEditorEmail({
      email,
      comments,
      emailType,
      titleText,
      targetUserName,
    })
  },
}
